Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.naming.ldap
Class PagedResultsControl

    java.lang.Object
      javax.naming.ldap.BasicControl
          javax.naming.ldap.PagedResultsControl

All Implemented Interfaces:
  Serializable, Control

    public final class PagedResultsControl

extends BasicControl

Requests that the results of a search operation be returned by the LDAP server in batches of a specified size. The requestor controls the rate at which batches are returned by the rate at which it invokes search operations.

The following code sample shows how the class may be used:

         // Open an LDAP association
         LdapContext ctx = new InitialLdapContext();

         // Activate paged results
         int pageSize = 20; // 20 entries per page
         byte[] cookie = null;
         int total;
         ctx.setRequestControls(new Control[]{
             new PagedResultsControl(pageSize, Control.CRITICAL) });

         do {
             // Perform the search
             NamingEnumeration results =
                 ctx.search("", "(objectclass=*)", new SearchControls());

             // Iterate over a batch of search results
             while (results != null && results.hasMore()) {
                 // Display an entry
                 SearchResult entry = (SearchResult)results.next();
                 System.out.println(entry.getName());
                 System.out.println(entry.getAttributes());

                 // Handle the entry's response controls (if any)
                 if (entry instanceof HasControls) {
                     // ((HasControls)entry).getControls();
                 }
             }
             // Examine the paged results control response
             Control[] controls = ctx.getResponseControls();
             if (controls != null) {
                 for (int i = 0; i < controls.length; i++) {
                     if (controls[i] instanceof PagedResultsResponseControl) {
                         PagedResultsResponseControl prrc =
                             (PagedResultsResponseControl)controls[i];
                         total = prrc.getResultSize();
                         cookie = prrc.getCookie();
                     } else {
                         // Handle other response controls (if any)
                     }
                 }
             }

             // Re-activate paged results
             ctx.setRequestControls(new Control[]{
                 new PagedResultsControl(pageSize, cookie, Control.CRITICAL) });
         } while (cookie != null);

         // Close the LDAP association
         ctx.close();
         ...

This class implements the LDAPv3 Control for paged-results as defined in RFC 2696. The control's value has the following ASN.1 definition:

         realSearchControlValue ::= SEQUENCE {
             size      INTEGER (0..maxInt),
                               -- requested page size from client
                               -- result set size estimate from server
             cookie    OCTET STRING
         }

Since:
  1.5
See Also:
  `PagedResultsResponseControl`, Serialized Form

Field Summary
`static String` | `OID` The paged-results control's assigned object identifier is 1.2.840.113556.1.4.319.

Fields inherited from class javax.naming.ldap.BasicControl
`criticality, id, value`

Fields inherited from interface javax.naming.ldap.Control
`CRITICAL, NONCRITICAL`

Constructor Summary
`PagedResultsControl(int pageSize, boolean criticality)` Constructs a control to set the number of entries to be returned per page of results.
`PagedResultsControl(int pageSize, byte[] cookie, boolean criticality)` Constructs a control to set the number of entries to be returned per page of results.

Method Summary

Methods inherited from class javax.naming.ldap.BasicControl
`getEncodedValue, getID, isCritical`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### OID

    public static final String OID

  The paged-results control's assigned object identifier is 1.2.840.113556.1.4.319.

  See Also:
    Constant Field Values

Constructor Detail

### PagedResultsControl

    public PagedResultsControl(int pageSize,
                               boolean criticality)
                        throws IOException

  Constructs a control to set the number of entries to be returned per page of results.

  Parameters:
    `pageSize` - The number of entries to return in a page.
    `criticality` - If true then the server must honor the control and return search results as indicated by pageSize or refuse to perform the search. If false, then the server need not honor the control.
  Throws:
    `IOException` - If an error was encountered while encoding the supplied arguments into a control.

### PagedResultsControl

    public PagedResultsControl(int pageSize,
                               byte[] cookie,
                               boolean criticality)
                        throws IOException

  Constructs a control to set the number of entries to be returned per page of results. The cookie is provided by the server and may be obtained from the paged-results response control.

  A sequence of paged-results can be abandoned by setting the pageSize to zero and setting the cookie to the last cookie received from the server.

  Parameters:
    `pageSize` - The number of entries to return in a page.
    `cookie` - A possibly null server-generated cookie.
    `criticality` - If true then the server must honor the control and return search results as indicated by pageSize or refuse to perform the search. If false, then the server need not honor the control.
  Throws:
    `IOException` - If an error was encountered while encoding the supplied arguments into a control.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.